Imports System.Threading

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnHigh As System.Windows.Forms.Button
    Friend WithEvents btnLow As System.Windows.Forms.Button
    Friend WithEvents btnAll As System.Windows.Forms.Button
    Friend WithEvents btnNormal As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnHigh = New System.Windows.Forms.Button
        Me.btnNormal = New System.Windows.Forms.Button
        Me.btnLow = New System.Windows.Forms.Button
        Me.btnAll = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'btnHigh
        '
        Me.btnHigh.Location = New System.Drawing.Point(48, 64)
        Me.btnHigh.Name = "btnHigh"
        Me.btnHigh.Size = New System.Drawing.Size(168, 24)
        Me.btnHigh.TabIndex = 0
        Me.btnHigh.Text = "Run High Priority Thread"
        '
        'btnNormal
        '
        Me.btnNormal.Location = New System.Drawing.Point(48, 104)
        Me.btnNormal.Name = "btnNormal"
        Me.btnNormal.Size = New System.Drawing.Size(168, 24)
        Me.btnNormal.TabIndex = 1
        Me.btnNormal.Text = "Run Normal Priority Thread"
        '
        'btnLow
        '
        Me.btnLow.Location = New System.Drawing.Point(48, 144)
        Me.btnLow.Name = "btnLow"
        Me.btnLow.Size = New System.Drawing.Size(168, 24)
        Me.btnLow.TabIndex = 2
        Me.btnLow.Text = "Run Low Priority Thread"
        '
        'btnAll
        '
        Me.btnAll.Location = New System.Drawing.Point(48, 8)
        Me.btnAll.Name = "btnAll"
        Me.btnAll.Size = New System.Drawing.Size(168, 24)
        Me.btnAll.TabIndex = 3
        Me.btnAll.Text = "Run All Threads"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(256, 181)
        Me.Controls.Add(Me.btnAll)
        Me.Controls.Add(Me.btnLow)
        Me.Controls.Add(Me.btnNormal)
        Me.Controls.Add(Me.btnHigh)
        Me.Name = "Form1"
        Me.Text = "howto_net_thread_priority"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The threads.
    Private m_HighThread As Thread
    Private m_NormalThread As Thread
    Private m_LowThread As Thread

    Private Sub btnHigh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHigh.Click
        MakeThread(m_HighThread, "High", ThreadPriority.AboveNormal)
    End Sub
    Private Sub btnNormal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNormal.Click
        MakeThread(m_NormalThread, "Normal", ThreadPriority.Normal)
    End Sub
    Private Sub btnLow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLow.Click
        MakeThread(m_LowThread, "Low", ThreadPriority.BelowNormal)
    End Sub

    Private Sub btnAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAll.Click
        MakeThread(m_LowThread, "Low", ThreadPriority.BelowNormal)
        MakeThread(m_NormalThread, "Normal", ThreadPriority.Normal)
        MakeThread(m_HighThread, "High", ThreadPriority.AboveNormal)
    End Sub

    ' Make a thread with the indicated priority.
    Private Sub MakeThread(ByRef thread_variable As Thread, ByVal thread_name As String, ByVal thread_priority As ThreadPriority)
        ' See if the thread is already running.
        Dim is_running As Boolean
        If thread_variable Is Nothing Then
            is_running = False
        Else
            is_running = thread_variable.IsAlive
        End If

        ' If the thread is already running, do nothing.
        If is_running Then Exit Sub

        ' Make the thread.
        Dim new_counter As New Counter(thread_name)
        thread_variable = New Thread(AddressOf new_counter.Run)
        thread_variable.Priority = thread_priority
        thread_variable.IsBackground = True
        thread_variable.Name = thread_name

        ' Start the thread.
        thread_variable.Start()
    End Sub
End Class

' This class's Run method displays a count in the Output window.
Public Class Counter
    ' This counter's number.
    Private m_Name As String

    ' The iteration count.
    Private m_Count As Integer = 0

    Public Sub New(ByVal my_name As String)
        m_Name = my_name
    End Sub

    ' Count off 10 half second intervals in the Output window.
    Public Sub Run()
        For i As Integer = 1 To 10
            ' Display the next message.
            Debug.WriteLine(m_Name & " " & m_Count)
            m_Count += 1

            ' See when we should display the next message.
            Dim next_time As DateTime = Now.AddSeconds(0.5)

            ' Waste half a second.
            ' Note that we do not sleep, call DoEvents,
            ' or otherwise give up control of the CPU.
            Do While Now < next_time
                ' Wait a bit.
            Loop
        Next i
    End Sub
End Class